{% macro fileupload_bs4row_js() %}
<!--region html_fr_dataurl__xx() -->
<script>
function html_fr_dataurl__PNG(dataurl, _id) {
    return `
    <div class="thumb_border" data_id="${_id}">
        <div class="file_thumb"
             style="background-image: url('${dataurl}' )"
        >
            <div class="del_thumb"> <i class="fa fa-trash" aria-hidden="true"></i> </div>
        </div>
    </div>
    `
}

function html_fr_dataurl__PDF(dataurl, _id) {
    return `
    <div class="thumb_border" data_id="${_id}">
        <div class="file_thumb"
             style="background-image: url('{{ url_for('static', filename='img/file-pdf-regular.svg')}}' ); background-size: unset"
             data-dataurl="${dataurl}"
        >
            <div class="del_thumb"> <i class="fa fa-trash" aria-hidden="true"></i> </div>
        </div>
    </div>
    `
}

function html_fr_file(filetype, file_dataurl, _id) {
    if      (filetype.includes('png') ) { return html_fr_dataurl__PNG(file_dataurl, _id) }
    else if (filetype.includes('pdf') ) { return html_fr_dataurl__PDF(file_dataurl, _id) }
    else                                { alert(`ERROR filetype NOT supported ${filetype}`) }
}

</script>
<!--endregion html_fr_dataurl__xx() -->

<script>
function add_file(uploader_fileformfield, owner) {
    var selected_f = uploader_fileformfield[0].files[0]  {#TODO we see .files here, ie multi files, but can only select 1 file in the popup, so how to have multi files selected and handle them? #}

    var fr=new FileReader() ; fr.readAsDataURL(selected_f) ; fr.onload = e=>{  // fr aka file_reader
        {# get dataurl #}
        var fc      = e.target.result {# fc aka the file_content as base64 dataurl eg data:xx;base64,AbbCCC... #}
        var dataurl = fc  // eg data:image/png;base64,wL2dvYWwgbW9yZ...

        //region save to db w/ api
        $.ajax({
            url: '{{ API_URL }}/fileupload',  method: 'POST',
            data: {
                'owner_id' : owner,
                'dataurl'  : dataurl,
                'filename' : selected_f.name,
                'filetype' : selected_f.type,
            },

        }).done(function(data){
            {# render html #}
            var html = html_fr_file(filetype=selected_f.type, file_dataurl=dataurl, _id=data.inserted._id)
            uploader_fileformfield.closest('.add_new_file').before(html)

        }).fail(function(jqXHR, textStatus) {
            alert('err') ; throw new Error(textStatus)
        })
        //endregion save to db w/ api

   }
}

{# click :uploader_thumb to upload file #}
$(()=>{
    {# body       click   elem css selector of the DYNAMIC  <-- click handler for dynaicly-created elem ref. https://stackoverflow.com/a/9484335/248616 #}
    $('body').on('click', '.uploader_thumb', function() {  {# click :uploader_thumb to popup file-selector-dialog ref. https://stackoverflow.com/a/16215950/248616 #}

        {# accordingly click the :uploader_fileformfield when clicking the :uploader_thumb #}
        $(this).next('.uploader_fileformfield').click()

        {# get filecontent of selected file ref. https://stackoverflow.com/a/40971885/248616 #}
        $(this).next('.uploader_fileformfield').one('change', function(){  {# use .one() to register once only ref. https://makandracards.com/makandra/36625-jquery-how-to-attach-an-event-handler-only-once #}
            const o = $(this).closest('.fileupload').attr('data-owner')
            add_file(uploader_fileformfield=$(this), owner=o)
        })

    })
})

{# click del icon to remove that thumb #}
$(()=>{

    {# body       click   elem css selector of the DYNAMIC  <-- click handler for dynamicaly-created elem ref. https://stackoverflow.com/a/9484335/248616 #}
    $('body').on('click', '.del_thumb', function(){
        const thumb_border_e = $(this).closest('.thumb_border')
        const _id            = thumb_border_e.attr('data_id')

        //region delete fr db w/ api
        $.ajax({
            url: `{{ API_URL }}/fileupload/${_id}`,  method: 'DELETE'
        }).done(function(data){
            {# remove html elem #}
            thumb_border_e.remove()

        }).fail(function(jqXHR, textStatus) {
            alert('err') ; throw new Error(textStatus)
        })
        //endregion delete fr db w/ api
    })

})

</script>

<script>
function filelist_to_html(filelist, owner) {
    //region filelist to f_html_all
    var f_html__all=''
    for (const f of filelist) {
        f_html__all += html_fr_file(f.filetype, f.dataurl, f._id)
    }
    //endregion filelist to :f_html_all

    /*region wrap :f_html_all to a bs4 row */
    var html=`
    <div class="row fileupload" data-owner="${owner}">
        <div class="col-lg-3 col-xs-12">${owner} fileupload</div>  {#TODO make this a :title param #}

        ${f_html__all}

        <div class="thumb_border add_new_file">
            <div class="file_thumb uploader_thumb"> <i class="fa fa-upload" aria-hidden="true"></i> </div>
            <input class="uploader_fileformfield" type="file" style="display: none">
        </div>
    </div>
    `
    /*endregion wrap :f_html_all to a bs4 row */
    return html
}
</script>
{% endmacro %}
